/*
 * 
 */
package UsedCase.diagram.edit.commands;

import org.eclipse.core.commands.ExecutionException;
import org.eclipse.core.runtime.IAdaptable;
import org.eclipse.core.runtime.IProgressMonitor;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.gmf.runtime.common.core.command.CommandResult;
import org.eclipse.gmf.runtime.emf.type.core.commands.EditElementCommand;
import org.eclipse.gmf.runtime.emf.type.core.requests.ReorientRelationshipRequest;

/**
 * @generated
 */
public class ExtendReorientCommand extends EditElementCommand {

	/**
	 * @generated
	 */
	private final int reorientDirection;

	/**
	 * @generated
	 */
	private final EObject oldEnd;

	/**
	 * @generated
	 */
	private final EObject newEnd;

	/**
	 * @generated
	 */
	public ExtendReorientCommand(ReorientRelationshipRequest request) {
		super(request.getLabel(), request.getRelationship(), request);
		reorientDirection = request.getDirection();
		oldEnd = request.getOldRelationshipEnd();
		newEnd = request.getNewRelationshipEnd();
	}

	/**
	 * @generated
	 */
	public boolean canExecute() {
		if (false == getElementToEdit() instanceof UsedCase.Extend) {
			return false;
		}
		if (reorientDirection == ReorientRelationshipRequest.REORIENT_SOURCE) {
			return canReorientSource();
		}
		if (reorientDirection == ReorientRelationshipRequest.REORIENT_TARGET) {
			return canReorientTarget();
		}
		return false;
	}

	/**
	 * @generated
	 */
	protected boolean canReorientSource() {
		if (!(oldEnd instanceof UsedCase.Node && newEnd instanceof UsedCase.Node)) {
			return false;
		}
		UsedCase.Node target = getLink().getTo();
		if (!(getLink().eContainer() instanceof UsedCase.Usecases)) {
			return false;
		}
		UsedCase.Usecases container = (UsedCase.Usecases) getLink()
				.eContainer();
		return UsedCase.diagram.edit.policies.UsedCaseBaseItemSemanticEditPolicy
				.getLinkConstraints().canExistExtend_4002(container, getLink(),
						getNewSource(), target);
	}

	/**
	 * @generated
	 */
	protected boolean canReorientTarget() {
		if (!(oldEnd instanceof UsedCase.Node && newEnd instanceof UsedCase.Node)) {
			return false;
		}
		UsedCase.Node source = getLink().getFrom();
		if (!(getLink().eContainer() instanceof UsedCase.Usecases)) {
			return false;
		}
		UsedCase.Usecases container = (UsedCase.Usecases) getLink()
				.eContainer();
		return UsedCase.diagram.edit.policies.UsedCaseBaseItemSemanticEditPolicy
				.getLinkConstraints().canExistExtend_4002(container, getLink(),
						source, getNewTarget());
	}

	/**
	 * @generated
	 */
	protected CommandResult doExecuteWithResult(IProgressMonitor monitor,
			IAdaptable info) throws ExecutionException {
		if (!canExecute()) {
			throw new ExecutionException(
					"Invalid arguments in reorient link command"); //$NON-NLS-1$
		}
		if (reorientDirection == ReorientRelationshipRequest.REORIENT_SOURCE) {
			return reorientSource();
		}
		if (reorientDirection == ReorientRelationshipRequest.REORIENT_TARGET) {
			return reorientTarget();
		}
		throw new IllegalStateException();
	}

	/**
	 * @generated
	 */
	protected CommandResult reorientSource() throws ExecutionException {
		getLink().setFrom(getNewSource());
		return CommandResult.newOKCommandResult(getLink());
	}

	/**
	 * @generated
	 */
	protected CommandResult reorientTarget() throws ExecutionException {
		getLink().setTo(getNewTarget());
		return CommandResult.newOKCommandResult(getLink());
	}

	/**
	 * @generated
	 */
	protected UsedCase.Extend getLink() {
		return (UsedCase.Extend) getElementToEdit();
	}

	/**
	 * @generated
	 */
	protected UsedCase.Node getOldSource() {
		return (UsedCase.Node) oldEnd;
	}

	/**
	 * @generated
	 */
	protected UsedCase.Node getNewSource() {
		return (UsedCase.Node) newEnd;
	}

	/**
	 * @generated
	 */
	protected UsedCase.Node getOldTarget() {
		return (UsedCase.Node) oldEnd;
	}

	/**
	 * @generated
	 */
	protected UsedCase.Node getNewTarget() {
		return (UsedCase.Node) newEnd;
	}
}
