/*
 * 
 */
package UsedCase.diagram.navigator;

import org.eclipse.core.runtime.IAdaptable;
import org.eclipse.gmf.runtime.common.ui.services.parser.IParser;
import org.eclipse.gmf.runtime.common.ui.services.parser.ParserOptions;
import org.eclipse.gmf.runtime.emf.core.util.EObjectAdapter;
import org.eclipse.gmf.runtime.emf.type.core.IElementType;
import org.eclipse.gmf.runtime.notation.View;
import org.eclipse.jface.resource.ImageDescriptor;
import org.eclipse.jface.resource.ImageRegistry;
import org.eclipse.jface.viewers.ITreePathLabelProvider;
import org.eclipse.jface.viewers.LabelProvider;
import org.eclipse.jface.viewers.TreePath;
import org.eclipse.jface.viewers.ViewerLabel;
import org.eclipse.swt.graphics.Image;
import org.eclipse.ui.IMemento;
import org.eclipse.ui.navigator.ICommonContentExtensionSite;
import org.eclipse.ui.navigator.ICommonLabelProvider;

/**
 * @generated
 */
public class UsedCaseNavigatorLabelProvider extends LabelProvider implements
		ICommonLabelProvider, ITreePathLabelProvider {

	/**
	 * @generated
	 */
	static {
		UsedCase.diagram.part.UsedCaseDiagramEditorPlugin
				.getInstance()
				.getImageRegistry()
				.put("Navigator?UnknownElement", ImageDescriptor.getMissingImageDescriptor()); //$NON-NLS-1$
		UsedCase.diagram.part.UsedCaseDiagramEditorPlugin
				.getInstance()
				.getImageRegistry()
				.put("Navigator?ImageNotFound", ImageDescriptor.getMissingImageDescriptor()); //$NON-NLS-1$
	}

	/**
	 * @generated
	 */
	public void updateLabel(ViewerLabel label, TreePath elementPath) {
		Object element = elementPath.getLastSegment();
		if (element instanceof UsedCase.diagram.navigator.UsedCaseNavigatorItem
				&& !isOwnView(((UsedCase.diagram.navigator.UsedCaseNavigatorItem) element)
						.getView())) {
			return;
		}
		label.setText(getText(element));
		label.setImage(getImage(element));
	}

	/**
	 * @generated
	 */
	public Image getImage(Object element) {
		if (element instanceof UsedCase.diagram.navigator.UsedCaseNavigatorGroup) {
			UsedCase.diagram.navigator.UsedCaseNavigatorGroup group = (UsedCase.diagram.navigator.UsedCaseNavigatorGroup) element;
			return UsedCase.diagram.part.UsedCaseDiagramEditorPlugin
					.getInstance().getBundledImage(group.getIcon());
		}

		if (element instanceof UsedCase.diagram.navigator.UsedCaseNavigatorItem) {
			UsedCase.diagram.navigator.UsedCaseNavigatorItem navigatorItem = (UsedCase.diagram.navigator.UsedCaseNavigatorItem) element;
			if (!isOwnView(navigatorItem.getView())) {
				return super.getImage(element);
			}
			return getImage(navigatorItem.getView());
		}

		// Due to plugin.xml content will be called only for "own" views
		if (element instanceof IAdaptable) {
			View view = (View) ((IAdaptable) element).getAdapter(View.class);
			if (view != null && isOwnView(view)) {
				return getImage(view);
			}
		}

		return super.getImage(element);
	}

	/**
	 * @generated
	 */
	public Image getImage(View view) {
		switch (UsedCase.diagram.part.UsedCaseVisualIDRegistry
				.getVisualID(view)) {
		case UsedCase.diagram.edit.parts.UsecasesEditPart.VISUAL_ID:
			return getImage(
					"Navigator?Diagram?http://UsedCase/1.0?Usecases", UsedCase.diagram.providers.UsedCaseElementTypes.Usecases_1000); //$NON-NLS-1$
		case UsedCase.diagram.edit.parts.UsecaseEditPart.VISUAL_ID:
			return getImage(
					"Navigator?TopLevelNode?http://UsedCase/1.0?Usecase", UsedCase.diagram.providers.UsedCaseElementTypes.Usecase_2002); //$NON-NLS-1$
		case UsedCase.diagram.edit.parts.LinkEditPart.VISUAL_ID:
			return getImage(
					"Navigator?Link?http://UsedCase/1.0?Link", UsedCase.diagram.providers.UsedCaseElementTypes.Link_4003); //$NON-NLS-1$
		case UsedCase.diagram.edit.parts.ActorEditPart.VISUAL_ID:
			return getImage(
					"Navigator?TopLevelNode?http://UsedCase/1.0?Actor", UsedCase.diagram.providers.UsedCaseElementTypes.Actor_2001); //$NON-NLS-1$
		case UsedCase.diagram.edit.parts.ExtendEditPart.VISUAL_ID:
			return getImage(
					"Navigator?Link?http://UsedCase/1.0?Extend", UsedCase.diagram.providers.UsedCaseElementTypes.Extend_4002); //$NON-NLS-1$
		case UsedCase.diagram.edit.parts.IncludeEditPart.VISUAL_ID:
			return getImage(
					"Navigator?Link?http://UsedCase/1.0?Include", UsedCase.diagram.providers.UsedCaseElementTypes.Include_4001); //$NON-NLS-1$
		}
		return getImage("Navigator?UnknownElement", null); //$NON-NLS-1$
	}

	/**
	 * @generated
	 */
	private Image getImage(String key, IElementType elementType) {
		ImageRegistry imageRegistry = UsedCase.diagram.part.UsedCaseDiagramEditorPlugin
				.getInstance().getImageRegistry();
		Image image = imageRegistry.get(key);
		if (image == null
				&& elementType != null
				&& UsedCase.diagram.providers.UsedCaseElementTypes
						.isKnownElementType(elementType)) {
			image = UsedCase.diagram.providers.UsedCaseElementTypes
					.getImage(elementType);
			imageRegistry.put(key, image);
		}

		if (image == null) {
			image = imageRegistry.get("Navigator?ImageNotFound"); //$NON-NLS-1$
			imageRegistry.put(key, image);
		}
		return image;
	}

	/**
	 * @generated
	 */
	public String getText(Object element) {
		if (element instanceof UsedCase.diagram.navigator.UsedCaseNavigatorGroup) {
			UsedCase.diagram.navigator.UsedCaseNavigatorGroup group = (UsedCase.diagram.navigator.UsedCaseNavigatorGroup) element;
			return group.getGroupName();
		}

		if (element instanceof UsedCase.diagram.navigator.UsedCaseNavigatorItem) {
			UsedCase.diagram.navigator.UsedCaseNavigatorItem navigatorItem = (UsedCase.diagram.navigator.UsedCaseNavigatorItem) element;
			if (!isOwnView(navigatorItem.getView())) {
				return null;
			}
			return getText(navigatorItem.getView());
		}

		// Due to plugin.xml content will be called only for "own" views
		if (element instanceof IAdaptable) {
			View view = (View) ((IAdaptable) element).getAdapter(View.class);
			if (view != null && isOwnView(view)) {
				return getText(view);
			}
		}

		return super.getText(element);
	}

	/**
	 * @generated
	 */
	public String getText(View view) {
		if (view.getElement() != null && view.getElement().eIsProxy()) {
			return getUnresolvedDomainElementProxyText(view);
		}
		switch (UsedCase.diagram.part.UsedCaseVisualIDRegistry
				.getVisualID(view)) {
		case UsedCase.diagram.edit.parts.UsecasesEditPart.VISUAL_ID:
			return getUsecases_1000Text(view);
		case UsedCase.diagram.edit.parts.UsecaseEditPart.VISUAL_ID:
			return getUsecase_2002Text(view);
		case UsedCase.diagram.edit.parts.LinkEditPart.VISUAL_ID:
			return getLink_4003Text(view);
		case UsedCase.diagram.edit.parts.ActorEditPart.VISUAL_ID:
			return getActor_2001Text(view);
		case UsedCase.diagram.edit.parts.ExtendEditPart.VISUAL_ID:
			return getExtend_4002Text(view);
		case UsedCase.diagram.edit.parts.IncludeEditPart.VISUAL_ID:
			return getInclude_4001Text(view);
		}
		return getUnknownElementText(view);
	}

	/**
	 * @generated
	 */
	private String getUsecases_1000Text(View view) {
		return ""; //$NON-NLS-1$
	}

	/**
	 * @generated
	 */
	private String getUsecase_2002Text(View view) {
		IParser parser = UsedCase.diagram.providers.UsedCaseParserProvider
				.getParser(
						UsedCase.diagram.providers.UsedCaseElementTypes.Usecase_2002,
						view.getElement() != null ? view.getElement() : view,
						UsedCase.diagram.part.UsedCaseVisualIDRegistry
								.getType(UsedCase.diagram.edit.parts.UsecaseNameEditPart.VISUAL_ID));
		if (parser != null) {
			return parser.getPrintString(new EObjectAdapter(
					view.getElement() != null ? view.getElement() : view),
					ParserOptions.NONE.intValue());
		} else {
			UsedCase.diagram.part.UsedCaseDiagramEditorPlugin.getInstance()
					.logError("Parser was not found for label " + 5002); //$NON-NLS-1$
			return ""; //$NON-NLS-1$
		}
	}

	/**
	 * @generated
	 */
	private String getLink_4003Text(View view) {
		return ""; //$NON-NLS-1$
	}

	/**
	 * @generated
	 */
	private String getActor_2001Text(View view) {
		IParser parser = UsedCase.diagram.providers.UsedCaseParserProvider
				.getParser(
						UsedCase.diagram.providers.UsedCaseElementTypes.Actor_2001,
						view.getElement() != null ? view.getElement() : view,
						UsedCase.diagram.part.UsedCaseVisualIDRegistry
								.getType(UsedCase.diagram.edit.parts.ActorNameEditPart.VISUAL_ID));
		if (parser != null) {
			return parser.getPrintString(new EObjectAdapter(
					view.getElement() != null ? view.getElement() : view),
					ParserOptions.NONE.intValue());
		} else {
			UsedCase.diagram.part.UsedCaseDiagramEditorPlugin.getInstance()
					.logError("Parser was not found for label " + 5001); //$NON-NLS-1$
			return ""; //$NON-NLS-1$
		}
	}

	/**
	 * @generated
	 */
	private String getExtend_4002Text(View view) {
		IParser parser = UsedCase.diagram.providers.UsedCaseParserProvider
				.getParser(
						UsedCase.diagram.providers.UsedCaseElementTypes.Extend_4002,
						view.getElement() != null ? view.getElement() : view,
						UsedCase.diagram.part.UsedCaseVisualIDRegistry
								.getType(UsedCase.diagram.edit.parts.ExtendTitleEditPart.VISUAL_ID));
		if (parser != null) {
			return parser.getPrintString(new EObjectAdapter(
					view.getElement() != null ? view.getElement() : view),
					ParserOptions.NONE.intValue());
		} else {
			UsedCase.diagram.part.UsedCaseDiagramEditorPlugin.getInstance()
					.logError("Parser was not found for label " + 6002); //$NON-NLS-1$
			return ""; //$NON-NLS-1$
		}
	}

	/**
	 * @generated
	 */
	private String getInclude_4001Text(View view) {
		IParser parser = UsedCase.diagram.providers.UsedCaseParserProvider
				.getParser(
						UsedCase.diagram.providers.UsedCaseElementTypes.Include_4001,
						view.getElement() != null ? view.getElement() : view,
						UsedCase.diagram.part.UsedCaseVisualIDRegistry
								.getType(UsedCase.diagram.edit.parts.IncludeTitleEditPart.VISUAL_ID));
		if (parser != null) {
			return parser.getPrintString(new EObjectAdapter(
					view.getElement() != null ? view.getElement() : view),
					ParserOptions.NONE.intValue());
		} else {
			UsedCase.diagram.part.UsedCaseDiagramEditorPlugin.getInstance()
					.logError("Parser was not found for label " + 6001); //$NON-NLS-1$
			return ""; //$NON-NLS-1$
		}
	}

	/**
	 * @generated
	 */
	private String getUnknownElementText(View view) {
		return "<UnknownElement Visual_ID = " + view.getType() + ">"; //$NON-NLS-1$  //$NON-NLS-2$
	}

	/**
	 * @generated
	 */
	private String getUnresolvedDomainElementProxyText(View view) {
		return "<Unresolved domain element Visual_ID = " + view.getType() + ">"; //$NON-NLS-1$  //$NON-NLS-2$
	}

	/**
	 * @generated
	 */
	public void init(ICommonContentExtensionSite aConfig) {
	}

	/**
	 * @generated
	 */
	public void restoreState(IMemento aMemento) {
	}

	/**
	 * @generated
	 */
	public void saveState(IMemento aMemento) {
	}

	/**
	 * @generated
	 */
	public String getDescription(Object anElement) {
		return null;
	}

	/**
	 * @generated
	 */
	private boolean isOwnView(View view) {
		return UsedCase.diagram.edit.parts.UsecasesEditPart.MODEL_ID
				.equals(UsedCase.diagram.part.UsedCaseVisualIDRegistry
						.getModelID(view));
	}

}
