/*
 * 
 */
package UsedCase.diagram.part;

import org.eclipse.core.runtime.Platform;
import org.eclipse.emf.ecore.EAnnotation;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.gmf.runtime.notation.Diagram;
import org.eclipse.gmf.runtime.notation.View;
import org.eclipse.gmf.tooling.runtime.structure.DiagramStructure;

/**
 * This registry is used to determine which type of visual object should be
 * created for the corresponding Diagram, Node, ChildNode or Link represented
 * by a domain model object.
 * 
 * @generated
 */
public class UsedCaseVisualIDRegistry {

	/**
	 * @generated
	 */
	private static final String DEBUG_KEY = "usecase.example.diagram/debug/visualID"; //$NON-NLS-1$

	/**
	 * @generated
	 */
	public static int getVisualID(View view) {
		if (view instanceof Diagram) {
			if (UsedCase.diagram.edit.parts.UsecasesEditPart.MODEL_ID
					.equals(view.getType())) {
				return UsedCase.diagram.edit.parts.UsecasesEditPart.VISUAL_ID;
			} else {
				return -1;
			}
		}
		return UsedCase.diagram.part.UsedCaseVisualIDRegistry.getVisualID(view
				.getType());
	}

	/**
	 * @generated
	 */
	public static String getModelID(View view) {
		View diagram = view.getDiagram();
		while (view != diagram) {
			EAnnotation annotation = view.getEAnnotation("Shortcut"); //$NON-NLS-1$
			if (annotation != null) {
				return (String) annotation.getDetails().get("modelID"); //$NON-NLS-1$
			}
			view = (View) view.eContainer();
		}
		return diagram != null ? diagram.getType() : null;
	}

	/**
	 * @generated
	 */
	public static int getVisualID(String type) {
		try {
			return Integer.parseInt(type);
		} catch (NumberFormatException e) {
			if (Boolean.TRUE.toString().equalsIgnoreCase(
					Platform.getDebugOption(DEBUG_KEY))) {
				UsedCase.diagram.part.UsedCaseDiagramEditorPlugin.getInstance()
						.logError(
								"Unable to parse view type as a visualID number: "
										+ type);
			}
		}
		return -1;
	}

	/**
	 * @generated
	 */
	public static String getType(int visualID) {
		return Integer.toString(visualID);
	}

	/**
	 * @generated
	 */
	public static int getDiagramVisualID(EObject domainElement) {
		if (domainElement == null) {
			return -1;
		}
		if (UsedCase.UsedCasePackage.eINSTANCE.getUsecases().isSuperTypeOf(
				domainElement.eClass())
				&& isDiagram((UsedCase.Usecases) domainElement)) {
			return UsedCase.diagram.edit.parts.UsecasesEditPart.VISUAL_ID;
		}
		return -1;
	}

	/**
	 * @generated
	 */
	public static int getNodeVisualID(View containerView, EObject domainElement) {
		if (domainElement == null) {
			return -1;
		}
		String containerModelID = UsedCase.diagram.part.UsedCaseVisualIDRegistry
				.getModelID(containerView);
		if (!UsedCase.diagram.edit.parts.UsecasesEditPart.MODEL_ID
				.equals(containerModelID)
				&& !"UsedCase".equals(containerModelID)) { //$NON-NLS-1$
			return -1;
		}
		int containerVisualID;
		if (UsedCase.diagram.edit.parts.UsecasesEditPart.MODEL_ID
				.equals(containerModelID)) {
			containerVisualID = UsedCase.diagram.part.UsedCaseVisualIDRegistry
					.getVisualID(containerView);
		} else {
			if (containerView instanceof Diagram) {
				containerVisualID = UsedCase.diagram.edit.parts.UsecasesEditPart.VISUAL_ID;
			} else {
				return -1;
			}
		}
		switch (containerVisualID) {
		case UsedCase.diagram.edit.parts.UsecasesEditPart.VISUAL_ID:
			if (UsedCase.UsedCasePackage.eINSTANCE.getActor().isSuperTypeOf(
					domainElement.eClass())) {
				return UsedCase.diagram.edit.parts.ActorEditPart.VISUAL_ID;
			}
			if (UsedCase.UsedCasePackage.eINSTANCE.getUsecase().isSuperTypeOf(
					domainElement.eClass())) {
				return UsedCase.diagram.edit.parts.UsecaseEditPart.VISUAL_ID;
			}
			break;
		}
		return -1;
	}

	/**
	 * @generated
	 */
	public static boolean canCreateNode(View containerView, int nodeVisualID) {
		String containerModelID = UsedCase.diagram.part.UsedCaseVisualIDRegistry
				.getModelID(containerView);
		if (!UsedCase.diagram.edit.parts.UsecasesEditPart.MODEL_ID
				.equals(containerModelID)
				&& !"UsedCase".equals(containerModelID)) { //$NON-NLS-1$
			return false;
		}
		int containerVisualID;
		if (UsedCase.diagram.edit.parts.UsecasesEditPart.MODEL_ID
				.equals(containerModelID)) {
			containerVisualID = UsedCase.diagram.part.UsedCaseVisualIDRegistry
					.getVisualID(containerView);
		} else {
			if (containerView instanceof Diagram) {
				containerVisualID = UsedCase.diagram.edit.parts.UsecasesEditPart.VISUAL_ID;
			} else {
				return false;
			}
		}
		switch (containerVisualID) {
		case UsedCase.diagram.edit.parts.UsecasesEditPart.VISUAL_ID:
			if (UsedCase.diagram.edit.parts.ActorEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			if (UsedCase.diagram.edit.parts.UsecaseEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case UsedCase.diagram.edit.parts.ActorEditPart.VISUAL_ID:
			if (UsedCase.diagram.edit.parts.ActorNameEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case UsedCase.diagram.edit.parts.UsecaseEditPart.VISUAL_ID:
			if (UsedCase.diagram.edit.parts.UsecaseNameEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case UsedCase.diagram.edit.parts.IncludeEditPart.VISUAL_ID:
			if (UsedCase.diagram.edit.parts.IncludeTitleEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case UsedCase.diagram.edit.parts.ExtendEditPart.VISUAL_ID:
			if (UsedCase.diagram.edit.parts.ExtendTitleEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		}
		return false;
	}

	/**
	 * @generated
	 */
	public static int getLinkWithClassVisualID(EObject domainElement) {
		if (domainElement == null) {
			return -1;
		}
		if (UsedCase.UsedCasePackage.eINSTANCE.getInclude().isSuperTypeOf(
				domainElement.eClass())) {
			return UsedCase.diagram.edit.parts.IncludeEditPart.VISUAL_ID;
		}
		if (UsedCase.UsedCasePackage.eINSTANCE.getExtend().isSuperTypeOf(
				domainElement.eClass())) {
			return UsedCase.diagram.edit.parts.ExtendEditPart.VISUAL_ID;
		}
		if (UsedCase.UsedCasePackage.eINSTANCE.getLink().isSuperTypeOf(
				domainElement.eClass())) {
			return UsedCase.diagram.edit.parts.LinkEditPart.VISUAL_ID;
		}
		return -1;
	}

	/**
	 * User can change implementation of this method to handle some specific
	 * situations not covered by default logic.
	 * 
	 * @generated
	 */
	private static boolean isDiagram(UsedCase.Usecases element) {
		return true;
	}

	/**
	 * @generated
	 */
	public static boolean checkNodeVisualID(View containerView,
			EObject domainElement, int candidate) {
		if (candidate == -1) {
			//unrecognized id is always bad
			return false;
		}
		int basic = getNodeVisualID(containerView, domainElement);
		return basic == candidate;
	}

	/**
	 * @generated
	 */
	public static boolean isCompartmentVisualID(int visualID) {
		return false;
	}

	/**
	 * @generated
	 */
	public static boolean isSemanticLeafVisualID(int visualID) {
		switch (visualID) {
		case UsedCase.diagram.edit.parts.UsecasesEditPart.VISUAL_ID:
			return false;
		case UsedCase.diagram.edit.parts.ActorEditPart.VISUAL_ID:
		case UsedCase.diagram.edit.parts.UsecaseEditPart.VISUAL_ID:
			return true;
		default:
			break;
		}
		return false;
	}

	/**
	 * @generated
	 */
	public static final DiagramStructure TYPED_INSTANCE = new DiagramStructure() {
		/**
		 * @generated
		 */
		@Override
		public int getVisualID(View view) {
			return UsedCase.diagram.part.UsedCaseVisualIDRegistry
					.getVisualID(view);
		}

		/**
		 * @generated
		 */
		@Override
		public String getModelID(View view) {
			return UsedCase.diagram.part.UsedCaseVisualIDRegistry
					.getModelID(view);
		}

		/**
		 * @generated
		 */
		@Override
		public int getNodeVisualID(View containerView, EObject domainElement) {
			return UsedCase.diagram.part.UsedCaseVisualIDRegistry
					.getNodeVisualID(containerView, domainElement);
		}

		/**
		 * @generated
		 */
		@Override
		public boolean checkNodeVisualID(View containerView,
				EObject domainElement, int candidate) {
			return UsedCase.diagram.part.UsedCaseVisualIDRegistry
					.checkNodeVisualID(containerView, domainElement, candidate);
		}

		/**
		 * @generated
		 */
		@Override
		public boolean isCompartmentVisualID(int visualID) {
			return UsedCase.diagram.part.UsedCaseVisualIDRegistry
					.isCompartmentVisualID(visualID);
		}

		/**
		 * @generated
		 */
		@Override
		public boolean isSemanticLeafVisualID(int visualID) {
			return UsedCase.diagram.part.UsedCaseVisualIDRegistry
					.isSemanticLeafVisualID(visualID);
		}
	};

}
