/*
 * 
 */
package UsedCase.diagram.providers;

import java.util.HashSet;
import java.util.IdentityHashMap;
import java.util.Map;
import java.util.Set;

import org.eclipse.core.runtime.IAdaptable;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EClassifier;
import org.eclipse.emf.ecore.ENamedElement;
import org.eclipse.emf.ecore.EStructuralFeature;
import org.eclipse.gmf.runtime.emf.type.core.ElementTypeRegistry;
import org.eclipse.gmf.runtime.emf.type.core.IElementType;
import org.eclipse.jface.resource.ImageDescriptor;
import org.eclipse.jface.resource.ImageRegistry;
import org.eclipse.swt.graphics.Image;

/**
 * @generated
 */
public class UsedCaseElementTypes {

	/**
	 * @generated
	 */
	private UsedCaseElementTypes() {
	}

	/**
	 * @generated
	 */
	private static Map<IElementType, ENamedElement> elements;

	/**
	 * @generated
	 */
	private static ImageRegistry imageRegistry;

	/**
	 * @generated
	 */
	private static Set<IElementType> KNOWN_ELEMENT_TYPES;

	/**
	 * @generated
	 */
	public static final IElementType Usecases_1000 = getElementType("usecase.example.diagram.Usecases_1000"); //$NON-NLS-1$
	/**
	 * @generated
	 */
	public static final IElementType Actor_2001 = getElementType("usecase.example.diagram.Actor_2001"); //$NON-NLS-1$
	/**
	 * @generated
	 */
	public static final IElementType Usecase_2002 = getElementType("usecase.example.diagram.Usecase_2002"); //$NON-NLS-1$
	/**
	 * @generated
	 */
	public static final IElementType Include_4001 = getElementType("usecase.example.diagram.Include_4001"); //$NON-NLS-1$
	/**
	 * @generated
	 */
	public static final IElementType Extend_4002 = getElementType("usecase.example.diagram.Extend_4002"); //$NON-NLS-1$
	/**
	 * @generated
	 */
	public static final IElementType Link_4003 = getElementType("usecase.example.diagram.Link_4003"); //$NON-NLS-1$

	/**
	 * @generated
	 */
	private static ImageRegistry getImageRegistry() {
		if (imageRegistry == null) {
			imageRegistry = new ImageRegistry();
		}
		return imageRegistry;
	}

	/**
	 * @generated
	 */
	private static String getImageRegistryKey(ENamedElement element) {
		return element.getName();
	}

	/**
	 * @generated
	 */
	private static ImageDescriptor getProvidedImageDescriptor(
			ENamedElement element) {
		if (element instanceof EStructuralFeature) {
			EStructuralFeature feature = ((EStructuralFeature) element);
			EClass eContainingClass = feature.getEContainingClass();
			EClassifier eType = feature.getEType();
			if (eContainingClass != null && !eContainingClass.isAbstract()) {
				element = eContainingClass;
			} else if (eType instanceof EClass
					&& !((EClass) eType).isAbstract()) {
				element = eType;
			}
		}
		if (element instanceof EClass) {
			EClass eClass = (EClass) element;
			if (!eClass.isAbstract()) {
				return UsedCase.diagram.part.UsedCaseDiagramEditorPlugin
						.getInstance().getItemImageDescriptor(
								eClass.getEPackage().getEFactoryInstance()
										.create(eClass));
			}
		}
		// TODO : support structural features
		return null;
	}

	/**
	 * @generated
	 */
	public static ImageDescriptor getImageDescriptor(ENamedElement element) {
		String key = getImageRegistryKey(element);
		ImageDescriptor imageDescriptor = getImageRegistry().getDescriptor(key);
		if (imageDescriptor == null) {
			imageDescriptor = getProvidedImageDescriptor(element);
			if (imageDescriptor == null) {
				imageDescriptor = ImageDescriptor.getMissingImageDescriptor();
			}
			getImageRegistry().put(key, imageDescriptor);
		}
		return imageDescriptor;
	}

	/**
	 * @generated
	 */
	public static Image getImage(ENamedElement element) {
		String key = getImageRegistryKey(element);
		Image image = getImageRegistry().get(key);
		if (image == null) {
			ImageDescriptor imageDescriptor = getProvidedImageDescriptor(element);
			if (imageDescriptor == null) {
				imageDescriptor = ImageDescriptor.getMissingImageDescriptor();
			}
			getImageRegistry().put(key, imageDescriptor);
			image = getImageRegistry().get(key);
		}
		return image;
	}

	/**
	 * @generated
	 */
	public static ImageDescriptor getImageDescriptor(IAdaptable hint) {
		ENamedElement element = getElement(hint);
		if (element == null) {
			return null;
		}
		return getImageDescriptor(element);
	}

	/**
	 * @generated
	 */
	public static Image getImage(IAdaptable hint) {
		ENamedElement element = getElement(hint);
		if (element == null) {
			return null;
		}
		return getImage(element);
	}

	/**
	 * Returns 'type' of the ecore object associated with the hint.
	 * 
	 * @generated
	 */
	public static ENamedElement getElement(IAdaptable hint) {
		Object type = hint.getAdapter(IElementType.class);
		if (elements == null) {
			elements = new IdentityHashMap<IElementType, ENamedElement>();

			elements.put(Usecases_1000,
					UsedCase.UsedCasePackage.eINSTANCE.getUsecases());

			elements.put(Actor_2001,
					UsedCase.UsedCasePackage.eINSTANCE.getActor());

			elements.put(Usecase_2002,
					UsedCase.UsedCasePackage.eINSTANCE.getUsecase());

			elements.put(Include_4001,
					UsedCase.UsedCasePackage.eINSTANCE.getInclude());

			elements.put(Extend_4002,
					UsedCase.UsedCasePackage.eINSTANCE.getExtend());

			elements.put(Link_4003,
					UsedCase.UsedCasePackage.eINSTANCE.getLink());
		}
		return (ENamedElement) elements.get(type);
	}

	/**
	 * @generated
	 */
	private static IElementType getElementType(String id) {
		return ElementTypeRegistry.getInstance().getType(id);
	}

	/**
	 * @generated
	 */
	public static boolean isKnownElementType(IElementType elementType) {
		if (KNOWN_ELEMENT_TYPES == null) {
			KNOWN_ELEMENT_TYPES = new HashSet<IElementType>();
			KNOWN_ELEMENT_TYPES.add(Usecases_1000);
			KNOWN_ELEMENT_TYPES.add(Actor_2001);
			KNOWN_ELEMENT_TYPES.add(Usecase_2002);
			KNOWN_ELEMENT_TYPES.add(Include_4001);
			KNOWN_ELEMENT_TYPES.add(Extend_4002);
			KNOWN_ELEMENT_TYPES.add(Link_4003);
		}
		return KNOWN_ELEMENT_TYPES.contains(elementType);
	}

	/**
	 * @generated
	 */
	public static IElementType getElementType(int visualID) {
		switch (visualID) {
		case UsedCase.diagram.edit.parts.UsecasesEditPart.VISUAL_ID:
			return Usecases_1000;
		case UsedCase.diagram.edit.parts.ActorEditPart.VISUAL_ID:
			return Actor_2001;
		case UsedCase.diagram.edit.parts.UsecaseEditPart.VISUAL_ID:
			return Usecase_2002;
		case UsedCase.diagram.edit.parts.IncludeEditPart.VISUAL_ID:
			return Include_4001;
		case UsedCase.diagram.edit.parts.ExtendEditPart.VISUAL_ID:
			return Extend_4002;
		case UsedCase.diagram.edit.parts.LinkEditPart.VISUAL_ID:
			return Link_4003;
		}
		return null;
	}

}
